//
// Copyright (C) 1999-2002 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef WSDNXAPPDEV_H
#define WSDNXAPPDEV_H

#include <WSDappDev.h>
#define F_MEMGID

class WSDnxFormDev;

class WSDnxAppDev               :public WSDappDev {

  private:
  protected:
    void* _app_context;
    void* _color_map;
    WSCbool _have_color_map;
  public:
     WSDnxAppDev();
     virtual ~WSDnxAppDev();

     virtual void update();


     long setInitPrm(int, char**);
virtual long handleEvents();
virtual long dispatchEvent();
virtual long processEvent();
        long _dispatchEvent(WSCbool wait);
virtual long initialize();


virtual long     getDeviceResource();
virtual long     getWindowResource();
virtual long     getContextResource();
virtual long     getSpecialResource();

virtual WSCushort getWidth();
virtual WSCushort getHeight();

    virtual long loadGuiPolicy();
    virtual long saveGuiPolicy();

    WSCbool haveColorMap();
    void* getNewMemContext(WSCulong w,WSCulong h);
    void destroyMemContext(void*);
    void* getActiveWindow();

    WSCbool getMouseGrabbed();
    void setGrabTarget(WSDnxFormDev*);
    void setBtnPressGrabTarget(WSDnxFormDev*);
    WSDnxFormDev* getGrabTarget();
    WSDnxFormDev* getBtnPressGrabTarget();
//----------------------------------------------//
     WSMFclassDef(WSDnxAppDev,WSDappDev);
};
extern WSDnxAppDev* WSGInxAppDev();

extern void WSGFsetRect(WSCrect*,short,short,WSCushort,WSCushort);

#endif
